Index: /trunk/l10n/tspsg_uk.ts
===================================================================
--- /trunk/l10n/tspsg_uk.ts	(revision 103)
+++ /trunk/l10n/tspsg_uk.ts	(revision 104)
@@ -874,165 +875,165 @@
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="226"/>
+        <location filename="../ui/settingsdialog.ui" line="152"/>
         <source>Task</source>
         <translation>Задача</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="229"/>
+        <location filename="../ui/settingsdialog.ui" line="155"/>
         <source>Task generation and solving settings</source>
         <translation>Налаштування генерації та розв&apos;язку задач</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="240"/>
+        <location filename="../ui/settingsdialog.ui" line="166"/>
         <source>Fractional accuracy:</source>
         <translation>Точність дробових чисел:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="250"/>
+        <location filename="../ui/settingsdialog.ui" line="176"/>
         <source>Accuracy of the fractional values (in decimal places)</source>
         <translation>Точність дробових чисел (у знаках після коми)</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="299"/>
+        <location filename="../ui/settingsdialog.ui" line="225"/>
         <source>Minimum for random number generation</source>
         <translation>Нажня межа для генерації випадкових значень</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="319"/>
+        <location filename="../ui/settingsdialog.ui" line="245"/>
         <source>Maximum for random number generation</source>
         <translation>Верхня межа для генерації випадкових значень</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="331"/>
+        <location filename="../ui/settingsdialog.ui" line="257"/>
         <source>Generate fractional random values with the Fractional accuracy</source>
         <translation>Генерувати дробові випадкові числа з вказаною вище точністю</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="457"/>
+        <location filename="../ui/settingsdialog.ui" line="383"/>
         <source>Output font settings</source>
         <translation>Параметри шрифта</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="486"/>
+        <location filename="../ui/settingsdialog.ui" line="412"/>
         <source>&amp;Color...</source>
         <translation>&amp;Колір...</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="189"/>
+        <location filename="../ui/settingsdialog.ui" line="115"/>
         <source>Automatically resize rows and columns to their contents</source>
         <translation>Автоматично підганяти розмір рядків під їх зміст</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="177"/>
+        <location filename="../ui/settingsdialog.ui" line="103"/>
         <source>General</source>
         <translation>Загальні</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="180"/>
+        <location filename="../ui/settingsdialog.ui" line="106"/>
         <source>General TSPSG settings</source>
         <translation>Загальні налаштування TSPSG</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="192"/>
+        <location filename="../ui/settingsdialog.ui" line="118"/>
         <source>Autosize of rows and columns</source>
         <translation>Авторозмір рядків та колонок</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="202"/>
+        <location filename="../ui/settingsdialog.ui" line="128"/>
         <source>Use native File Open and File Save dialogs (uncheck to use Qt&apos;s Dialogs)</source>
         <translation>Використовувати системні діалоги відкриття та збереження файлу</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="275"/>
+        <location filename="../ui/settingsdialog.ui" line="201"/>
         <source>Task generation</source>
         <translation>Генерація задач</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="358"/>
+        <location filename="../ui/settingsdialog.ui" line="284"/>
         <source>Output</source>
         <translation>Виведення</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="361"/>
+        <location filename="../ui/settingsdialog.ui" line="287"/>
         <source>Solution output settings</source>
         <translation>Налаштування тексту розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="370"/>
+        <location filename="../ui/settingsdialog.ui" line="296"/>
         <source>Show solution steps&apos; matrices for every solution step</source>
         <translation>Показувати матриці кроків розв&apos;язку для кожного кроку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="373"/>
+        <location filename="../ui/settingsdialog.ui" line="299"/>
         <source>Show solution steps&apos; matrices</source>
         <translation>Показ матриць кроків розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="404"/>
+        <location filename="../ui/settingsdialog.ui" line="330"/>
         <source>Show or hide solution steps&apos; matrices based on number of cities in the task</source>
         <translation>Показувати матриці ходу розв&apos;язку в залежності від кількості міст</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="414"/>
+        <location filename="../ui/settingsdialog.ui" line="340"/>
         <source>Maximum number of cities to show solution steps&apos; matrices</source>
         <translation>Максимальна кількість міст для показу матриць кроків розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="466"/>
+        <location filename="../ui/settingsdialog.ui" line="392"/>
         <source>Font face for solution output</source>
         <translation>Вигляд шрифта для виводу</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="483"/>
+        <location filename="../ui/settingsdialog.ui" line="409"/>
         <source>Font color for solution output</source>
         <translation>Колір шрифта для виводу</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="334"/>
+        <location filename="../ui/settingsdialog.ui" line="260"/>
         <source>Fractional random values</source>
         <translation>Дробові випадкові числа</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="445"/>
+        <location filename="../ui/settingsdialog.ui" line="371"/>
         <source>Scroll to the end of solution output after solving</source>
         <translation>Прокручувати в кінець виводу після закінчення розв&apos;язку задачі</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="448"/>
+        <location filename="../ui/settingsdialog.ui" line="374"/>
         <source>Scroll to solution end</source>
         <translation>Прокручувати в кінець розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="205"/>
+        <location filename="../ui/settingsdialog.ui" line="131"/>
         <source>Use native file dialogs</source>
         <translation>Системні файлові діалоги</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="265"/>
+        <location filename="../ui/settingsdialog.ui" line="191"/>
         <source>In this mode the cost of travel from city 1 to city 2 and vice versa is the same</source>
         <translation>У цьому режимі вартість переїзду з міста 1 у місто 2 та навпаки співпадає</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="268"/>
+        <location filename="../ui/settingsdialog.ui" line="194"/>
         <source>Symmetric mode</source>
         <translation>Симетричний режим</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="286"/>
+        <location filename="../ui/settingsdialog.ui" line="212"/>
         <source>Minimal random:</source>
         <translation>Мінімальне випадкове:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="306"/>
+        <location filename="../ui/settingsdialog.ui" line="232"/>
         <source>Maximal random:</source>
         <translation>Максимальне випадкове:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="407"/>
+        <location filename="../ui/settingsdialog.ui" line="333"/>
         <source>Only when &lt;=</source>
         <translation>Лише коли ≤</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="417"/>
+        <location filename="../ui/settingsdialog.ui" line="343"/>
         <source> cities</source>
         <comment>Don&apos;t forget a space at the beginning!</comment>
@@ -1040,16 +1041,16 @@
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="469"/>
+        <location filename="../ui/settingsdialog.ui" line="395"/>
         <source>&amp;Font...</source>
         <translation>&amp;Шрифт...</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="103"/>
-        <location filename="../ui/settingsdialog.ui" line="109"/>
+        <location filename="../ui/settingsdialog.ui" line="66"/>
+        <location filename="../ui/settingsdialog.ui" line="72"/>
         <source>Help</source>
         <translation>Допомога</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="106"/>
+        <location filename="../ui/settingsdialog.ui" line="69"/>
         <source>Get preferences help</source>
         <translation>Отримати допомогу по налагодженням</translation>
Index: /trunk/src/defaults.h
===================================================================
--- /trunk/src/defaults.h	(revision 103)
+++ /trunk/src/defaults.h	(revision 104)
@@ -91,6 +91,10 @@
 	#define DEF_FONT_SIZE 10
 #endif // Q_OS_SYMBIAN
-//! Default font color
-#define DEF_FONT_COLOR Qt::black
+//! Default text color
+#define DEF_TEXT_COLOR QPalette().color(QPalette::Text)
+//! Default selected candidate color
+#define DEF_SELECTED_COLOR QColor(0x008000)
+//! Default alternate candidate color
+#define DEF_ALTERNATE_COLOR QColor(0xA00000)
 
 #endif // DEFAULTS_H
Index: /trunk/src/mainwindow.cpp
===================================================================
--- /trunk/src/mainwindow.cpp	(revision 103)
+++ /trunk/src/mainwindow.cpp	(revision 104)
@@ -512,10 +512,29 @@
 	pd.setValue(0);
 
+#ifdef DEBUG
+QTime t;
+	t.start();
+#endif
 	solutionText->clear();
-	solutionText->setDocumentTitle(tr("Solution of Variant #%1 task").arg(spinVariant->value()));
-	solutionText->append("<p>" + tr("Variant #%1").arg(spinVariant->value()) + "</p>");
-	solutionText->append("<p>" + tr("Task:") + "</p>");
-	solutionText->append(outputMatrix(matrix));
-	solutionText->append("<hr><p>" + tr("Solution of Variant #%1 task").arg(spinVariant->value()) + "</p>");
+#ifdef DEBUG
+	qDebug() << "Clear:" << t.elapsed();
+	t.restart();
+#endif
+	solutionText->setDocumentTitle(tr("Solution of Variant #%1 Task").arg(spinVariant->value()));
+
+QTextDocument *doc = solutionText->document();
+QTextCursor cur(doc);
+
+	cur.beginEditBlock();
+	cur.setBlockFormat(fmt_paragraph);
+	cur.insertText(tr("Variant #%1").arg(spinVariant->value()), fmt_default);
+	cur.insertBlock(fmt_paragraph);
+	cur.insertText(tr("Task:"));
+	outputMatrix(cur, matrix);
+	cur.insertHtml("<hr>");
+	cur.insertBlock(fmt_paragraph);
+	cur.insertText(tr("Solution of Variant #%1 Task").arg(spinVariant->value()), fmt_default);
+	cur.endEditBlock();
+
 SStep *step = root;
 	n = 1;
@@ -523,5 +542,12 @@
 	while (n < spinCities->value()) {
 		if (pd.wasCanceled()) {
+			pd.setLabelText(tr("Cleaning up..."));
+			pd.setMaximum(0);
+			pd.setCancelButton(NULL);
+			pd.show();
+			QApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
+			solver.cleanup(true);
 			solutionText->clear();
+			toggleSolutionActions(false);
 			return;
 		}
@@ -530,9 +556,12 @@
 		if (step->prNode->prNode != NULL || ((step->prNode->prNode == NULL) && (step->plNode->prNode == NULL))) {
 			if (n != spinCities->value()) {
-				solutionText->append("<p>" + tr("Step #%1").arg(n++) + "</p>");
+				cur.beginEditBlock();
+				cur.insertBlock(fmt_paragraph);
+				cur.insertText(tr("Step #%1").arg(n++));
 				if (settings->value("Output/ShowMatrix", DEF_SHOW_MATRIX).toBool() && (!settings->value("Output/UseShowMatrixLimit", DEF_USE_SHOW_MATRIX_LIMIT).toBool() || (settings->value("Output/UseShowMatrixLimit", DEF_USE_SHOW_MATRIX_LIMIT).toBool() && (spinCities->value() <= settings->value("Output/ShowMatrixLimit", DEF_SHOW_MATRIX_LIMIT).toInt())))) {
-					solutionText->append(outputMatrix(*step));
+					outputMatrix(cur, *step);
 				}
-				solutionText->append("<p>" + tr("Selected candidate for branching: %1.").arg(tr("(%1;%2)").arg(step->candidate.nRow + 1).arg(step->candidate.nCol + 1)) + "</p>");
+				cur.insertBlock(fmt_paragraph);
+				cur.insertText(tr("Selected candidate for branching: %1.").arg(tr("(%1;%2)").arg(step->candidate.nRow + 1).arg(step->candidate.nCol + 1)), fmt_default);
 				if (!step->alts.empty()) {
 SCandidate cand;
@@ -543,7 +572,10 @@
 						alts += tr("(%1;%2)").arg(cand.nRow + 1).arg(cand.nCol + 1);
 					}
-					solutionText->append("<p class=\"hasalts\">" + tr("%n alternate candidate(s) for branching: %1.","",step->alts.count()).arg(alts) + "</p>");
+					cur.insertBlock(fmt_paragraph);
+					cur.insertText(tr("%n alternate candidate(s) for branching: %1.", "", step->alts.count()).arg(alts), fmt_altlist);
 				}
-				solutionText->append("<p>&nbsp;</p>");
+				cur.insertBlock(fmt_paragraph);
+				cur.insertText(" ", fmt_default);
+				cur.endEditBlock();
 			}
 		}
@@ -558,20 +590,32 @@
 	pd.setValue(n);
 
+	cur.beginEditBlock();
+	cur.insertBlock(fmt_paragraph);
 	if (solver.isOptimal())
-		solutionText->append("<p>" + tr("Optimal path:") + "</p>");
+		cur.insertText(tr("Optimal path:"));
 	else
-		solutionText->append("<p>" + tr("Resulting path:") + "</p>");
-	solutionText->append("<p>&nbsp;&nbsp;" + solver.getSortedPath() + "</p>");
+		cur.insertText(tr("Resulting path:"));
+
+	cur.insertBlock(fmt_paragraph);
+	cur.insertText("  " + solver.getSortedPath());
+
+	cur.insertBlock(fmt_paragraph);
 	if (isInteger(step->price))
-		solutionText->append("<p>" + tr("The price is <b>%n</b> unit(s).", "", qRound(step->price)) + "</p>");
+		cur.insertHtml("<p>" + tr("The price is <b>%n</b> unit(s).", "", qRound(step->price)) + "</p>");
 	else
-		solutionText->append("<p>" + tr("The price is <b>%1</b> units.").arg(step->price, 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt()) + "</p>");
+		cur.insertHtml("<p>" + tr("The price is <b>%1</b> units.").arg(step->price, 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt()) + "</p>");
 	if (!solver.isOptimal()) {
-		solutionText->append("<p>&nbsp;</p>");
-		solutionText->append("<p>" + tr("<b>WARNING!!!</b><br>This result is a record, but it may not be optimal.<br>Iterations need to be continued to check whether this result is optimal or get an optimal one.") + "</p>");
-	}
+		cur.insertBlock(fmt_paragraph);
+		cur.insertText(" ");
+		cur.insertBlock(fmt_paragraph);
+		cur.insertHtml("<p>" + tr("<b>WARNING!!!</b><br>This result is a record, but it may not be optimal.<br>Iterations need to be continued to check whether this result is optimal or get an optimal one.") + "</p>");
+	}
+	cur.endEditBlock();
+#ifdef DEBUG
+	qDebug() << "Generate:" << t.elapsed();
+#endif
 
 	if (settings->value("Output/ScrollToEnd", DEF_SCROLL_TO_END).toBool()) {
-		// Scrolling to the end of text.
+		// Scrolling to the end of the text.
 		solutionText->moveCursor(QTextCursor::End);
 	} else
@@ -701,12 +745,39 @@
 void MainWindow::initDocStyleSheet()
 {
-QColor color = settings->value("Output/Color",DEF_FONT_COLOR).value<QColor>();
+	solutionText->document()->setDefaultFont(settings->value("Output/Font", QFont(DEF_FONT_FAMILY, DEF_FONT_SIZE)).value<QFont>());
+
+	fmt_paragraph.setTopMargin(0);
+	fmt_paragraph.setRightMargin(10);
+	fmt_paragraph.setBottomMargin(0);
+	fmt_paragraph.setLeftMargin(10);
+
+	fmt_table.setTopMargin(5);
+	fmt_table.setRightMargin(10);
+	fmt_table.setBottomMargin(5);
+	fmt_table.setLeftMargin(10);
+	fmt_table.setBorder(0);
+	fmt_table.setBorderStyle(QTextFrameFormat::BorderStyle_None);
+	fmt_table.setCellSpacing(5);
+
+	fmt_center.setAlignment(Qt::AlignHCenter);
+
+QColor color = settings->value("Output/Colors/Text", DEF_TEXT_COLOR).value<QColor>();
 QColor hilight;
 	if (color.value() < 192)
-		hilight.setHsv(color.hue(),color.saturation(),127 + qRound(color.value() / 2));
+		hilight.setHsv(color.hue(), color.saturation(), 127 + qRound(color.value() / 2));
 	else
-		hilight.setHsv(color.hue(),color.saturation(),color.value() / 2);
-	solutionText->document()->setDefaultStyleSheet("* {color: " + color.name() +";} p {margin: 0px 10px;} table {margin: 5px;} td {padding: 1px 5px;} .hasalts {color: " + hilight.name() + ";} .selected {color: #A00000; font-weight: bold;} .alternate {color: #008000; font-weight: bold;}");
-	solutionText->document()->setDefaultFont(settings->value("Output/Font",QFont(DEF_FONT_FAMILY,DEF_FONT_SIZE)).value<QFont>());
+		hilight.setHsv(color.hue(), color.saturation(), color.value() / 2);
+
+	solutionText->document()->setDefaultStyleSheet(QString("* {color: %1;}").arg(color.name()));
+	fmt_default.setForeground(QBrush(color));
+
+	fmt_selected.setForeground(QBrush(settings->value("Output/Colors/Selected", DEF_SELECTED_COLOR).value<QColor>()));
+	fmt_selected.setFontWeight(QFont::Bold);
+
+	fmt_alternate.setForeground(QBrush(settings->value("Output/Colors/Alternate", DEF_ALTERNATE_COLOR).value<QColor>()));
+	fmt_alternate.setFontWeight(QFont::Bold);
+	fmt_altlist.setForeground(QBrush(hilight));
+
+	solutionText->setTextColor(color);
 }
 
@@ -811,36 +882,37 @@
 }
 
-QString MainWindow::outputMatrix(const TMatrix &matrix) const
+void MainWindow::outputMatrix(QTextCursor &cur, const TMatrix &matrix)
 {
 int n = spinCities->value();
-QString output(""), line;
-	output.append("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">");
+QTextTable *table = cur.insertTable(n, n, fmt_table);
+
 	for (int r = 0; r < n; r++) {
-		line = "<tr>";
 		for (int c = 0; c < n; c++) {
+			cur = table->cellAt(r, c).firstCursorPosition();
+			cur.setBlockFormat(fmt_center);
+			cur.setBlockCharFormat(fmt_default);
 			if (matrix.at(r).at(c) == INFINITY)
-				line += "<td align=\"center\">"INFSTR"</td>";
+				cur.insertText(INFSTR);
 			else
-				line += isInteger(matrix.at(r).at(c)) ? QString("<td align=\"center\">%1</td>").arg(matrix.at(r).at(c)) : QString("<td align=\"center\">%1</td>").arg(matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt());
-		}
-		line += "</tr>";
-		output.append(line);
-	}
-	output.append("</table>");
-	return output;
-}
-
-QString MainWindow::outputMatrix(const SStep &step) const
+				cur.insertText(isInteger(matrix.at(r).at(c)) ? QString("%1").arg(matrix.at(r).at(c)) : QString("%1").arg(matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt()));
+		}
+		QApplication::processEvents();
+	}
+	cur.movePosition(QTextCursor::End);
+}
+
+void MainWindow::outputMatrix(QTextCursor &cur, const SStep &step)
 {
 int n = spinCities->value();
-QString output(""), line;
-	output.append("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">");
+QTextTable *table = cur.insertTable(n, n, fmt_table);
+
 	for (int r = 0; r < n; r++) {
-		line = "<tr>";
 		for (int c = 0; c < n; c++) {
+			cur = table->cellAt(r, c).firstCursorPosition();
+			cur.setBlockFormat(fmt_center);
 			if (step.matrix.at(r).at(c) == INFINITY)
-				line += "<td align=\"center\">"INFSTR"</td>";
+				cur.insertText(INFSTR, fmt_default);
 			else if ((r == step.candidate.nRow) && (c == step.candidate.nCol))
-				line += isInteger(step.matrix.at(r).at(c)) ? QString("<td align=\"center\" class=\"selected\">%1</td>").arg(step.matrix.at(r).at(c)) : QString("<td align=\"center\" class=\"selected\">%1</td>").arg(step.matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt());
+				cur.insertText(isInteger(step.matrix.at(r).at(c)) ? QString("%1").arg(step.matrix.at(r).at(c)) : QString("%1").arg(step.matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt()), fmt_selected);
 			else {
 SCandidate cand;
@@ -848,14 +920,13 @@
 				cand.nCol = c;
 				if (step.alts.contains(cand))
-					line += isInteger(step.matrix.at(r).at(c)) ? QString("<td align=\"center\" class=\"alternate\">%1</td>").arg(step.matrix.at(r).at(c)) : QString("<td align=\"center\" class=\"alternate\">%1</td>").arg(step.matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt());
+					cur.insertText(isInteger(step.matrix.at(r).at(c)) ? QString("%1").arg(step.matrix.at(r).at(c)) : QString("%1").arg(step.matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt()), fmt_alternate);
 				else
-					line += isInteger(step.matrix.at(r).at(c)) ? QString("<td align=\"center\">%1</td>").arg(step.matrix.at(r).at(c)) : QString("<td align=\"center\">%1</td>").arg(step.matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt());
+					cur.insertText(isInteger(step.matrix.at(r).at(c)) ? QString("%1").arg(step.matrix.at(r).at(c)) : QString("%1").arg(step.matrix.at(r).at(c), 0, 'f', settings->value("Task/FractionalAccuracy", DEF_FRACTIONAL_ACCURACY).toInt()), fmt_default);
 			}
 		}
-		line += "</tr>";
-		output.append(line);
-	}
-	output.append("</table>");
-	return output;
+		QApplication::processEvents();
+	}
+
+	cur.movePosition(QTextCursor::End);
 }
 
@@ -958,6 +1029,5 @@
 #endif // Q_OS_WINCE_WM
 
-	solutionText->document()->setDefaultFont(settings->value("Output/Font",QFont(DEF_FONT_FAMILY,DEF_FONT_SIZE)).value<QFont>());
-	solutionText->setTextColor(settings->value("Output/Color",DEF_FONT_COLOR).value<QColor>());
+	solutionText->document()->setDefaultFont(settings->value("Output/Font", QFont(DEF_FONT_FAMILY, DEF_FONT_SIZE)).value<QFont>());
 	solutionText->setWordWrapMode(QTextOption::WordWrap);
 
Index: /trunk/src/mainwindow.h
===================================================================
--- /trunk/src/mainwindow.h	(revision 103)
+++ /trunk/src/mainwindow.h	(revision 104)
@@ -101,4 +101,13 @@
 #endif // Q_OS_WINCE_WM
 
+	// Formats
+	QTextTableFormat fmt_table;
+	QTextBlockFormat fmt_paragraph,
+		fmt_center;
+	QTextCharFormat fmt_default,
+		fmt_selected,
+		fmt_alternate,
+		fmt_altlist;
+
 	void closeEvent(QCloseEvent *ev);
 	bool hasUpdater() const;
@@ -107,6 +116,6 @@
 	bool loadLanguage(const QString &lang = QString());
 	bool maybeSave();
-	QString outputMatrix(const TMatrix &matrix) const;
-	QString outputMatrix(const SStep &step) const;
+	void outputMatrix(QTextCursor &cur, const TMatrix &matrix);
+	void outputMatrix(QTextCursor &cur, const SStep &step);
 	void retranslateUi(bool all = true);
 	bool saveTask();
Index: /trunk/src/settingsdialog.cpp
===================================================================
--- /trunk/src/settingsdialog.cpp	(revision 103)
+++ /trunk/src/settingsdialog.cpp	(revision 104)
@@ -41,4 +41,12 @@
 	buttonBox->button(QDialogButtonBox::Cancel)->setStatusTip(tr("Close without saving preferences"));
 	buttonBox->button(QDialogButtonBox::Cancel)->setCursor(QCursor(Qt::PointingHandCursor));
+
+QPalette p = bgWhite->palette();
+	p.setColor(QPalette::Window, p.color(QPalette::Base));
+	bgWhite->setPalette(p);
+
+	p = lineHorizontal->palette();
+	p.setColor(QPalette::Window, p.color(QPalette::Text));
+	lineHorizontal->setPalette(p);
 
 #ifdef HANDHELD
@@ -195,5 +203,5 @@
 
 	font = settings->value("Font",QFont(DEF_FONT_FAMILY,DEF_FONT_SIZE)).value<QFont>();
-	color = settings->value("Color",DEF_FONT_COLOR).value<QColor>();
+	color = settings->value("Colors/Text", DEF_TEXT_COLOR).value<QColor>();
 	settings->endGroup();
 
@@ -239,5 +247,5 @@
 		if (QMessageBox::question(this, tr("Settings Reset"), tr("Do you really want to <b>reset all application settings to their defaults</b>?"), QMessageBox::RestoreDefaults | QMessageBox::Cancel) == QMessageBox::RestoreDefaults) {
 			_newFont = (font != QFont(DEF_FONT_FAMILY, DEF_FONT_SIZE));
-			_newColor = (color != DEF_FONT_COLOR);
+			_newColor = (color != DEF_TEXT_COLOR);
 			settings->remove("");
 			settings->setValue("SettingsReset", true);
@@ -280,5 +288,5 @@
 		settings->setValue("Font", font);
 	if (_newColor)
-		settings->setValue("Color", color);
+		settings->setValue("Colors/Text", color);
 	settings->endGroup();
 	QDialog::accept();
Index: /trunk/tspsg.pro
===================================================================
--- /trunk/tspsg.pro	(revision 103)
+++ /trunk/tspsg.pro	(revision 104)
@@ -62,4 +62,5 @@
 	DESTDIR = debug
 	DEFINES += DEBUG
+#	CONFIG += console
 	D = d
 }
@@ -78,5 +79,5 @@
 l10n.files = l10n/*.qm
 #share.files =
-docs.files = COPYING README
+docs.files = COPYING README.txt
 INSTALLS += target l10n share docs
 
@@ -156,5 +157,5 @@
 	docs.sources = $$docs.files
 	docs.pkg_prerules = \
-		"\"README\" - \"\", FILETEXT, TEXTCONTINUE" \
+		"\"README.txt\" - \"\", FILETEXT, TEXTCONTINUE" \
 		"\"COPYING\" - \"\", FILETEXT, TEXTEXIT"
 	DEPLOYMENT += share l10n docs
Index: /trunk/ui/mainwindow.ui
===================================================================
--- /trunk/ui/mainwindow.ui	(revision 103)
+++ /trunk/ui/mainwindow.ui	(revision 104)
@@ -182,4 +182,7 @@
 	   <property name="statusTip">
 		<string>Solution steps</string>
+	   </property>
+	   <property name="undoRedoEnabled">
+		<bool>false</bool>
 	   </property>
 	   <property name="readOnly">
